#
# Conditional build:
%bcond_with	cg	# CG for Pixel Shader support
%bcond_with	devil	# DevIL instead of builtin SOIL for image loading
%bcond_without	jack	# JACK plugin
%bcond_without	openmp	# OpenMP for multi-core parallelization
%bcond_with	xmms	# XMMS plugin (deprecated; wants libxmms.pc, which is not provided)

%define		pkgname	projectM
Summary:	Awesome music visualizer
Summary(pl.UTF-8):	Imponujący wizualizator muzyki
Name:		libprojectM
Version:	2.1.0
Release:	3
Epoch:		1
License:	LGPL v2.1+
Group:		Libraries
Source0:	http://downloads.sourceforge.net/projectm/projectM-complete-%{version}-Source.tar.gz
# Source0-md5:	debf30f7ce94ff0102f06fbb0cc4e92b
Patch0:		paths.patch
Patch1:		pkgconfig.patch
Patch2:		c++14.patch
Patch3:		test-link.patch
URL:		http://projectm.sourceforge.net/
%{?with_DevIL:BuildRequires:	DevIL-devel}
%{?with_DevIL:BuildRequires:	DevIL-ILUT-devel}
BuildRequires:	OpenGL-devel
BuildRequires:	QtCore-devel >= 4
BuildRequires:	QtGui-devel >= 4
BuildRequires:	QtOpenGL-devel >= 4
BuildRequires:	QtXml-devel >= 4
BuildRequires:	SDL-devel
%{?with_cg:BuildRequires:	cg-devel}
BuildRequires:	cmake >= 2.8.0
BuildRequires:	desktop-file-utils
BuildRequires:	freetype-devel >= 1:2.3.5
BuildRequires:	ftgl-devel >= 2.1.3
BuildRequires:	glew-devel >= 1.4.0
%{?with_jack:BuildRequires:	jack-audio-connection-kit-devel}
%{?with_openmp:BuildRequires:	libgomp-devel}
BuildRequires:	libstdc++-devel
BuildRequires:	libvisual-devel >= 0.4.0
BuildRequires:	pkgconfig
BuildRequires:	pulseaudio-devel >= 0.9.8
BuildRequires:	rpmbuild(macros) >= 1.605
%{?with_xmms:BuildRequires:	xmms-devel}
Requires:	fonts-TTF-bitstream-vera
Requires:	ftgl-devel >= 2.1.3
Requires:	glew-devel >= 1.4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
projectM is a reimplementation of Milkdrop under OpenGL. It is an
awesome music visualizer. There is nothing better in the world of
Unix.

%description -l pl.UTF-8
projectM jest reimplementacją projektu Milkdrop na OpenGL. Jest
imponującym wizualizatorem muzyki. Nie ma nic lepszego w świecie
uniksa.

%package devel
Summary:	Header files for projectM library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki projectM
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
Header files for projectM library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki projectM.

%package qt
Summary:	The Qt frontend to the projectM visualization library
Summary(pl.UTF):	Graficzny interfejs Qt do biblioteki wizualizacyjnej projectM
Group:		X11/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description qt
projectM-qt is a GUI designed to enhance the projectM user and preset
writer experience. It provides a way to browse, search, rate presets
and setup preset playlists for jack-projectM and pulseaudio-projectM.

%description qt -l pl.UTF-8
projectM-qt to graficzny interfejs użytkownika, mający poprawić
doznania użytkownika oraz piszącego ustawienia projectM. Daje
możliwość przeglądania, wyszukiwania, ustawiania współczynników oraz
predefiniowanych list odtwarzania dla wtyczek jack-projectM oraz
pulseaudio-projectM.

%package qt-devel
Summary:	Header files for projectM Qt library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki projectM Qt
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}
Requires:	%{name}-qt = %{epoch}:%{version}-%{release}
Requires:	QtCore-devel >= 4
Requires:	QtGui-devel >= 4
Requires:	QtOpenGL-devel >= 4
Requires:	QtXml-devel >= 4

%description qt-devel
Header files for projectM Qt library.

%description qt-devel -l pl.UTF-8
Pliki nagłówkowe biblioteki projectM Qt.

%package -n jack-projectM
Summary:	The projectM visualization plugin for JACK
Summary(pl.UTF-8):	Wtyczka wizualizacji dla JACK-a
License:	GPLv2+ and MIT
Group:		Applications/Multimedia
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-qt = %{epoch}:%{version}-%{release}

%description -n jack-projectM
This package allows the use of the projectM visualization plugin
through any JACK compatible applications.

%description -n jack-projectM -l pl.UTF-8
Ten pakiet pozwala na używanie wtyczki wizualizacji projectM we
wszystkich aplikacjach wykorzystujących system dźwięku JACK.

%package -n pulseaudio-projectM
Summary:	The projectM visualization plugin for pulseaudio
Summary(pl.UTF-8):	Wtyczka wizualizacji dla pulseaudio
Group:		Applications/Multimedia
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	%{name}-qt = %{epoch}:%{version}-%{release}
Requires:	pulseaudio-libs >= 0.9.8

%description -n pulseaudio-projectM
This package allows the use of the projectM visualization plugin
through any pulseaudio compatible applications.

%description -n pulseaudio-projectM -l pl.UTF-8
Ten pakiet pozwala na używanie wtyczki wizualizacji projectM we
wszystkich aplikacjach wykorzystujących system dźwięku pulseaudio.

%package -n libvisual-projectM
Summary:	ProjectM plugin for libvisual
Summary(pl.UTF-8):	Wtyczka ProjectM dla libvisual
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	libvisual >= 0.4

%description -n libvisual-projectM
projectM is a reimplementation of Milkdrop under OpenGL. This is a
plugin for libvisual visualization library.

%description -n libvisual-projectM -l pl.UTF-8
projectM jest reimplementacją projektu Milkdrop na OpenGL. Ten pakiet
zawiera wtyczkę dla biblioteki wizualizacji libvisual.

%prep
%setup -q -n projectM-complete-%{version}-Source
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
install -d build
cd build
%cmake \
	-DCMAKE_LIB_DIR=%{_libdir} \
	-DprojectM_FONT_MENU="/usr/share/fonts/TTF/Vera.ttf" \
	-DprojectM_FONT_TITLE="/usr/share/fonts/TTF/VeraMono.ttf" \
	%{?with_jack:-DINCLUDE-PROJECTM-JACK=ON} \
	-DINCLUDE-PROJECTM-LIBVISUAL-ALSA=ON \
	-DINCLUDE-PROJECTM-TEST=OFF \
	%{?with_xmms:-DINCLUDE-PROJECTM-XMMS=ON} \
	%{?with_cg:-DUSE_CG=ON} \
	%{?with_devil:-DUSE_DEVIL=ON} \
	%{!?with_openmp:-DUSE_OPENMP=OFF} \
	..
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

# omitted by CMakeLists.txt
install -d $RPM_BUILD_ROOT%{_mandir}/man1
cp -p src/projectM-jack/*.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -p src/projectM-pulseaudio/*.1 $RPM_BUILD_ROOT%{_mandir}/man1

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	qt -p /sbin/ldconfig
%postun	qt -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
# COPYING is just license information, not actual LGPL text
%doc AUTHORS.txt FAQ.txt TODO.txt src/README src/libprojectM/{COPYING,ChangeLog}
%attr(755,root,root) %{_libdir}/libprojectM.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libprojectM.so.2
%dir %{_datadir}/%{pkgname}
%{_datadir}/%{pkgname}/config.inp
%dir %{_datadir}/%{pkgname}/presets
%{_datadir}/%{pkgname}/presets/*.milk
%{_datadir}/%{pkgname}/presets/*.prjm
%{_datadir}/%{pkgname}/presets/*.tga
%dir %{_datadir}/%{pkgname}/shaders
%{_datadir}/%{pkgname}/shaders/*.cg

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libprojectM.so
%{_includedir}/%{name}
%{_pkgconfigdir}/libprojectM.pc

%files qt
%defattr(644,root,root,755)
%doc src/projectM-qt/ReadMe
%attr(755,root,root) %{_libdir}/libprojectM-qt.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libprojectM-qt.so.1
%{_pixmapsdir}/prjm16-transparent.svg

%files qt-devel
%defattr(644,root,root,755)
%doc src/projectM-qt/ReadMe
%attr(755,root,root) %{_libdir}/libprojectM-qt.so
%{_includedir}/%{name}-qt
%{_pkgconfigdir}/libprojectM-qt.pc

%if %{with jack}
%files -n jack-projectM
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/projectM-jack
%{_desktopdir}/projectM-jack.desktop
%{_mandir}/man1/projectM-jack.1*
%endif

%files -n pulseaudio-projectM
%defattr(644,root,root,755)
%doc src/projectM-pulseaudio/AUTHORS
%attr(755,root,root) %{_bindir}/projectM-pulseaudio
%{_desktopdir}/projectM-pulseaudio.desktop
%{_mandir}/man1/projectM-pulseaudio.1*

%files -n libvisual-projectM
%defattr(644,root,root,755)
%doc src/projectM-libvisual/{ChangeLog,AUTHORS}
%attr(755,root,root) %{_bindir}/projectM-libvisual-alsa
%attr(755,root,root) %{_libdir}/libvisual-0.4/actor/libprojectM_libvisual.so
%{_desktopdir}/projectM-libvisual-alsa.desktop
%changelog
* Wed Mar 25 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libprojectM.git;a=log;h=master

* Wed Mar 25 2020 Jan Rękorajski <baggins@pld-linux.org> 0f3096f
- release 3 (by relup.sh)

* Sun Mar 31 2019 Jan Rękorajski <baggins@pld-linux.org> 2b4c8ef
- release 2 (by relup.sh)

* Sun May 21 2017 Jakub Bogusz <qboosh@pld-linux.org> df91eff
- completed pl, dependencies and docs; added some bconds

* Sun Mar 12 2017 Jan Rękorajski <baggins@pld-linux.org> 08c2ceb
- removed outdated TODO
- added new subpackages
- updated BRs
- rel 1

* Sun Mar 12 2017 Jan Rękorajski <baggins@pld-linux.org> 45737e8
- patch cleanup
- added libvisual plugin subpackage

* Sun Mar 12 2017 Jan Rękorajski <baggins@pld-linux.org> 5338528
- updated to 2.0.1
- need adding new subpackages
- drop static lib

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> 033a712
- release 10 (by relup.sh)

* Sun Jul 12 2015 Jan Rękorajski <baggins@pld-linux.org> 8380d3f
- release 9 (by relup.sh)

* Fri Mar 13 2015 Jan Rękorajski <baggins@pld-linux.org> 59d2a61
- release 8 (by relup.sh)

* Tue Jan 21 2014 Jan Rękorajski <baggins@pld-linux.org> 1c758b2
- fix freetype detection
- rel 7

* Sun Dec 18 2011 Jakub Bogusz <qboosh@pld-linux.org> 7b020ff
- more BRs
- include COPYING in doc (copyright and license notes, not actual LGPL text)
- adjusted as-needed patch (but no success, cmake fault)

* Thu Nov 17 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> e818073
- release 6

* Wed Aug 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 45eabbd
- release 5

* Mon Sep 06 2010 Elan Ruusamäe <glen@pld-linux.org> a7d135e
- add patches from clementine 0.5; rel 4

* Thu Jul 08 2010 lisu <lisu@pld-linux.org> 380f104
- force pkgconfig to use -L/usr/lib or -L/usr/lib64 (avoid situations when pkg-config --libs libprojectM returns "-L-libprojectM")

* Thu Jul 08 2010 lisu <lisu@pld-linux.org> 10672d0
- force pkgconfig to use -L/usr/lib or -L/usr/lib64 (avoid situations when pkg-config --libs libprojectM returns "-L-libprojectM")
- rel 3

* Wed Jul 07 2010 Elan Ruusamäe <glen@pld-linux.org> f5c4e73
- cmake as needed broken, disable; rel 2

* Wed Jul 07 2010 Elan Ruusamäe <glen@pld-linux.org> 7b12719
- up to 2.0.1

* Sat Feb 27 2010 sparky <sparky@pld-linux.org> 57351de
- unify %attr() %ghost order

* Tue Sep 22 2009 Adam Gołębiowski <adamg@pld-linux.org> 2edd33b
- new; missing include

